<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="企微账号" prop="qwUserName">
             <el-input
               v-model="queryParams.qwUserName"
               placeholder="请输入企微昵称"
               clearable
               size="small"
               @keyup.enter.native="handleQuery"
             />
      </el-form-item>


      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="QwWorkTaskList" @selection-change="handleSelectionChange">
    <el-table-column type="selection" width="55" align="center" />
    <el-table-column label="企微账号" align="center" prop="qwUserName" />
	<el-table-column label="销售昵称" align="center" prop="companyUserName" />
	<el-table-column label="待处理" align="center" prop="status0" />
	<el-table-column label="已处理" align="center" prop="status1" />
	<el-table-column label="待处理完课" align="center" prop="status2" />
	<el-table-column label="已处理完课" align="center" prop="status3" />
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改企微任务看板对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="备注" prop="remark">
          <el-input  v-model="form.remark" placeholder="请输入备注"  type="textarea" :rows="3"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listQwWorkTask, getQwWorkTask, delQwWorkTask, addQwWorkTask, updateQwWorkTask, exportQwWorkTask,allListQwWorkTask } from "@/api/qw/QwWorkTask";
import {getMyQwUserList, getMyQwCompanyList, handleInputAuthAppKey, updateUser} from "@/api/qw/user";
export default {
  name: "QwWorkTask",
  data() {
    return {
	  actName:"0",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
	  myQwUserList:[],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 企微任务看板表格数据
      QwWorkTaskList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 状态 0 待处理 1 已处理 3 过期字典
      statusOptions: [],
      // 类别 1先导 2 课程 3 大小转 4 转人工字典
      typeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        extId: null,
        qwUserId: null,
        status: 0,
        type: null,
        title: null,
        score: null,
        sopId: null,
        companyId: null,
        companyUserId: null,
		qwUserId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
	this.handleGetMyQwUserList();
    this.getDicts("sys_qw_work_task_status").then(response => {
      this.statusOptions = response.data;
    });
    this.getDicts("sys_qw_work_task_type").then(response => {
      this.typeOptions = response.data;
    });
  },
  methods: {
	getScoreStyle(score) {
	let backgroundColor = '';
	  if (score >= 15) {
		backgroundColor = '#ff4d4f';    // 红色
	  } else if (score >= 9) {
		backgroundColor = '#ff7d45';    // 橘红
	  } else if (score >= 4) {
		backgroundColor = '#ffec3d';    // 黄色
	  } else {
		backgroundColor = '#ffffff';    // 白色
	  }
	  return { 
		'background-color': backgroundColor,
		'padding': '5px 10px',
		'border-radius': '4px'
	  };
	},
	formatTime(timeStr) {
	      if (!timeStr && timeStr !== 0) return '';
	      
	      // 处理数字和字符串输入
	      const str = String(timeStr).padStart(4, '0');
	      
	      // 提取有效部分
	      const hours = str.substring(0, 2);
	      const minutes = str.substring(2, 4);
	      
	      // 简单验证
	      if (hours > 23 || minutes > 59) return '无效时间';
	      
	      return `${hours}:${minutes}`;
	    },
    /** 查询企微任务看板列表 */
    getList() {
      this.loading = true;
      allListQwWorkTask(this.queryParams).then(response => {
        this.QwWorkTaskList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
	handleClickX(tab, event) {
	  this.queryParams.status=tab.name;
	  this.handleQuery();
	},
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        extId: null,
        qwUserId: null,
        status: 0,
        type: null,
        title: null,
        remark: null,
        score: null,
        sopId: null,
        companyId: null,
        companyUserId: null,
        createTime: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
	handleGetMyQwUserList(){
	 this.getList();
	},
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加企微任务看板";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
        this.form = row;
        this.open = true;
        this.title = "处理任务";

    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateQwWorkTask(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addQwWorkTask(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除企微任务看板编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delQwWorkTask(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有企微任务看板数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportQwWorkTask(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
